unit Unit1;

{
  10-12-2021
  N-polygon diagonals explorer
  paint,count intersections
  magnifier to inspect
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, clipbrd, math;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Label1: TLabel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    Label3: TLabel;
    Label4: TLabel;
    PaintBox2: TPaintBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label5: TLabel;
    SaveDialog1: TSaveDialog;
    Label6: TLabel;
    BitBtn3: TBitBtn;
    Label7: TLabel;
    PaintBox3: TPaintBox;
    CheckBox2: TCheckBox;
    BitBtn4: TBitBtn;
    Label8: TLabel;
    EnlBox: TPaintBox;
    magnBox: TPaintBox;
    procedure PaintBox1Paint(Sender: TObject);
    procedure Label1MouseEnter(Sender: TObject);
    procedure Label1MouseLeave(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Label1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox2Paint(Sender: TObject);
    procedure PaintBox2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure PaintBox3Paint(Sender: TObject);
    procedure PaintBox3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn4Click(Sender: TObject);
    procedure EnlBoxPaint(Sender: TObject);
    procedure EnlBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure magnBoxPaint(Sender: TObject);
    procedure magnBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const colorlist : array[0..11] of dword =
                  ($000000,$000080,$0000ff,
                   $00ff00,$0080ff,$00ffff,
                   $ff0000,$ff0080,$ff00ff,
                   $808080,$c0c0c0,$ffffff);
      INTSlistmax = 10000;
      maxEdge = 60;

      fake : array[1..8] of dword = ($12345678,$11111111,$22222222,$89abcdef,
                                     $01020304,$FEDCBA98,$19283746,$54545454);
                                     //avoid false malware detection

type TCpoint = record
                x,y : word;     //absolute pixel position
                rx,ry : single; //real value relative to screen center 
               end;
     TMouseproc = (mDown,mMove,mUp);
     TIntersection = record
                      count : byte;
                      x,y : single;
                     end;

var Alist : array[1..maxEdge] of TCpoint;
    edgecount : byte = 3;
    INTSlist : array[1..INTSlistmax] of TIntersection;
    INTSlistsize : word;
    map,map1,map2 : TBitmap;
    rect1,rect2 : Trect;
    rect1F,rect2F : boolean;
    fullrect : Trect;
    mouseX,mouseY : smallInt;
    mouseActive : boolean;
    point1,point2 : byte;
    mouseX1,mouseY1,mouseX2,mouseY2 : smallInt;
    drawrect : Trect;
    colorNr : byte;
    penwidth : byte = 1;
    arc : single = 2*pi/3;
    tanArc : single;
    timercode : byte;
    busy : boolean;               //calculating intersections
    statOK : boolean;
    magCode : byte;
    magSelected : boolean;
    magX,magY : smallInt;         //center position on paintbox
    magGripX,magGripY : smallInt; //mouse coords relative to glass center
    statistics : array[2..9] of word;

//-- rectangle paint area control

procedure unirect(var rd : Trect; const rs : Trect);
begin
 if rd.Left > rs.Left then rd.Left := rs.Left;
 if rd.Top > rs.Top then rd.Top := rs.Top;
 if rd.Right < rs.Right then rd.right := rs.right;
 if rd.Bottom < rs.Bottom then rd.Bottom := rs.Bottom;
end;

procedure addrect1(const r : Trect);
begin
 if rect1F then unirect(rect1,r)
  else rect1 := r;
 rect1F := true;
end;

procedure addrect2(const r : Trect);
begin
 if rect2F then unirect(rect2,r)
  else rect2 := r;
 rect2F := true;
end;

function packrect(x1,y1,x2,y2 : smallInt) : Trect;
var h : smallInt;
begin
 if x1 > x2 then begin
                  h := x1; x1 := x2; x2 := h;
                 end;
 if y1 > y2 then begin
                  h := y1; y1 := y2; y2 := h;
                 end;
 with result do
  begin
   left := x1-1;
   top := y1-1;
   right := x2+2;
   bottom := y2+2;
  end;
end;

procedure copymap12;
begin
 if rect1F then
  begin
   map2.canvas.copyrect(rect1,map1.Canvas,rect1);
   unirect(rect2,rect1);
   rect2F := true;
   rect1F := false;
  end;
end;

procedure copymap2box;
begin
 if rect2F then
  begin
   form1.PaintBox1.Canvas.CopyRect(rect2,map2.Canvas,rect2);
   rect2F := false;
  end;
end;

procedure map1tobox;
begin
 addrect1(fullrect);
 copymap12;
 copymap2box;
end;

procedure setEdgeCount(newcount : byte);
const ff = '0.##';
begin
 edgecount := newCount;
 arc := 2*pi/edgecount;
 tanArc := tan(arc);
 with form1 do
  begin
   label1.Caption := inttostr(edgecount);
   label3.Caption := formatfloat(ff,360/edgecount);
  end;
end;

procedure drawline(x1,y1,x2,y2 : smallInt; pw : byte);
//pw: penwidth
begin
 with map.canvas do
  begin
   pen.Width := pw;
   pen.color := colorlist[colorNr];
   moveto(x1,y1);
   lineto(x2,y2);
   lineto(x2,y2);
   drawrect := packrect(x1,y1,x2,y2);
  end;
end;

procedure drawChord(p1,p2,penwidth : byte);
//enter in chord table
var x1,y1,x2,y2 : word;
begin
 x1 := Alist[p1].x;
 y1 := Alist[p1].y;
 x2 := Alist[p2].x;
 y2 := Alist[p2].y;
 drawline(x1,y1,x2,y2,penwidth);
end;

procedure Arc2XY(var x,y : single; a : byte);
var na : single;
begin
 na := arc*(a-1);
 x := 480*sin(na);
 y := 480*cos(na);
end;

function checkSection(x,y : single) : boolean;
begin
 if x + 1e-3 >= 0 then
  begin
   y := abs(y);
   if y < 1e-6 then result:= false
    else result := x/y + 1e-6 < tanArc;
  end
  else result := false;
end;

procedure paintcircle;
//circle + diagonals in paintbox1
//set Alist (angle list)
var i,j : byte;
    x,y : word;
    rx,ry : single;
begin
 busy := true;
 map := map1;
 for i := 1 to edgecount do
  begin
   arc2XY(rx,ry,i);
   Alist[i].x := round(rx)+500;
   Alist[i].y := 500-round(ry); 
   Alist[i].rx := rx;
   Alist[i].ry := ry;
  end;
 with map do with canvas do
  begin
   brush.style := bsSolid;
   brush.color := $e0e0e0;
   fillrect(rect(0,0,width,height));
   pen.Width := 1;
   brush.Color := $ffffff;
   ellipse(20,20,981,981);
   for i := 1 to edgecount - 1 do
    for j := i+1 to edgecount do drawChord(i,j,1);
   pen.color := $000000;
   brush.Color := $000000;
   for i := 1 to edgecount do
    begin
     x := Alist[i].x;
     y := Alist[i].y;
     ellipse(x-2,y-2,x+3,y+3);
    end;
   ellipse(498,498,503,503);
   brush.Style := bsClear;
   ellipse(20,20,981,981);
  end;
 busy := false;
end;

function GetIntersection(var x,y : single; a1,a2,b1,b2 : byte) : boolean;
//return intersection of diagonals a12, b12
var a1x,a1y,a2x,a2y,b1x,b1y,b2x,b2y : single;
    dax,day,dbx,dby,F,d : single;
begin
 a1x := Alist[a1].rx;
 a1y := Alist[a1].ry;
 a2x := Alist[a2].rx;
 a2y := Alist[a2].ry;
 b1x := Alist[b1].rx;
 b1y := Alist[b1].ry;
 b2x := Alist[b2].rx;
 b2y := Alist[b2].ry;
 dax := a2x - a1x;
 day := a2y - a1y;
 dbx := b2x - b1x;
 dby := b2y - b1y;
 d := dax*dby - day*dbx;
 result := abs(d) > 1e-3;
 if result then
  begin
   F := (dby*(b1x - a1x) + dbx*(a1y - b1y))/d;
   if (F > 0) and (F < 1) then
    begin
     x := a1x + F*dax;
     y := a1y + F*day;
    end else result :=false;
  end;
end;

function GetDotColor(c : byte) : dword;
begin
 case c of
      2 : result := $808080;    //grey
      3 : result := $0000ff;    //red
      4 : result := $00b000;    //dark green
      5 : result := $ff8000;    //blue
      6 : result := $ffff00;    //light blue
      7 : result := $00c0ff;    //orange
      8 : result := $ff00ff;    //purple
      else result := $00000000; //black
 end;//case
end;

procedure paintIntersections(sx,sy : single; count : byte);
//paint intersection point (sx,sy) of chords
//count : number of intersecting lines
//sx,sy are in segment 1, paint points  in all sections
var r : Trect;
    x,y : word;
    i : byte;
    a,sina,cosa,rx,ry : single;
    clr : dword;
begin
 clr := getDotColor(count);
 with map2.Canvas do
  begin
   pen.Color := clr;
   brush.color := clr;
   brush.Style := bsSolid;
   for i := 0 to edgecount - 1 do
    begin
     a := i*unit1.arc;
     sina := sin(a);
     cosa := cos(a);
     rx := sx*cosa + sy*sina;
     ry := sy*cosa - sx*sina;
     x := round(rx)+500;
     y := 500-round(ry);
     r := rect(x-2,y-2,x+3,y+3);
     ellipse(r);
     form1.PaintBox1.Canvas.CopyRect(r,map2.canvas,r);
    end;//with
  end;//for
end;

procedure AddIntersection(x,y : single);
var i : word;
    hit : boolean;
begin
 i := 1;
 hit := false;
 while (hit = false) and (i < INTSlistsize) do
  begin
   if (abs(x - INTSlist[i].x) < 0.1) and
      (abs(y - INTSlist[i].y) < 0.1) then
    begin
     inc(INTSlist[i].count);
     hit := true;
    end else inc(i);
  end;
  if hit = false then
   begin
    inc(INTSlistsize);
    INTSlist[INTSlistsize].x := x;
    INTSlist[INTSlistsize].y := y;
    INTSlist[INTSlistsize].count := 1;
   end;
end;

procedure ProcessINTSlist;
var i,j : smallInt;
    HIS : TIntersection;
begin
 for i := 1 to INTSlistsize do     //C(n,2) to n conversion
  if INTSlist[i].count > 0 then
   case INTSlist[i].count of
     1 : INTSlist[i].count := 2;
     6 : INTSlist[i].count := 4;
    10 : INTSlist[i].count := 5;
    15 : INTSlist[i].count := 6;
    21 : INTSlist[i].count := 7;
    28 : INTSlist[i].count := 8;
    end;
 for i := 1 to INTSlistsize-1 do     //sort list
  for j := i+1 to INTSlistsize do
   if INTSlist[i].count > INTSlist[j].count then
    begin
     HIS := INTSlist[i];
     INTSlist[i] := INTSlist[j];
     INTSlist[j] := HIS;
    end;
end;

procedure CalcIntersections;
//angles are numbered A1,A2,B1,B2  1:start 2:end
var A1,A2,B1,B2,A2end,B2start : byte;
    sx,sy : single;
    I : word;
begin
 A1 := 1;
 for i := 1 to INTSlistmax do INTSlist[i].count := 0;
 INTSlistsize := 0;
 A2end := (edgecount shr 1) + 1;
 for A2 := A1 + 2 to A2end do
  begin
   for B1 := A1 + 1 to A2 - 1 do
    for B2 := B1 + ((edgecount + 2) shr 1) to edgecount do
     if getIntersection(sx,sy,A1,A2,B1,B2) then
      if checkSection(sx,sy) then addIntersection(sx,sy);
  end;//for A1,2
 if edgecount < 7 then exit;

 for A1 := 2 to ((edgecount+1) shr 1) - 2 do
  for A2 := A1 + (edgecount shr 1) + 1 to edgecount - 1 do
   for B1 := A1 + 1 to ((edgecount-1) shr 1) do
    begin
     B2start := A2 + 1;
     if B2start < B1 + (edgecount shr 1) + 1 then
      B2start := B1 + ((edgecount) shr 1 + 1);
     for B2 := B2start to edgecount do
      if getIntersection(sx,sy,A1,A2,B1,B2) then
       if checksection(sx,sy) then addIntersection(sx,sy);
    end;
end;

procedure ProcIntersections;
var i : word;
begin
 busy := true;
 calcIntersections;
 processINTSlist;
 for i := 1 to INTSlistsize do
  with INTSlist[i] do paintIntersections(x,y,count);
 statOK := true;
 busy := false;
end;

procedure checkOnPoint(var pnt : byte);
//during drawing / mouse movement
var i : byte;
    x,y : smallInt;
    hit : boolean;
begin
 i := 1;
 hit := false;
 while (hit = false) and (i <= edgecount) do
  begin
   x := Alist[i].x;
   y := Alist[i].y;
   if (mouseX > x-5) and (mouseX < x+5) and
      (mouseY > y-5) and (mouseY < y+5) then hit := true
    else inc(i);
  end;
 if hit then pnt := i else pnt := 0;
end;

function makepointrect(n : byte) : Trect;
begin
 with result do
  begin
   left := Alist[n].x-5;
   top := Alist[n].y-5;
   right := left + 11;
   bottom := top + 11;
  end;
end;

procedure markpoint(n : byte);
//mark begin or end of a line
var i : byte;
    r : Trect;
begin
 if n= 0 then exit;
//
 r := makepointrect(n);
 with map2.Canvas do
  begin
   pen.Color := $ff;
   pen.Width := 1;
   with r do
    for i := 0 to 1 do
     begin
      moveto(left+i,top+i);
      lineto(left+i,bottom-i-1);
      lineto(right-i-1,bottom-i-1);
      lineto(right-i-1,top+i);
      lineto(left+i,top+i);
     end;
  end;
 addrect2(r);
 copymap2box;
end;

procedure unmarkpoint(n : byte);
var r : Trect;
begin
 if n = 0 then exit;
//
 r := makepointrect(n);
 addrect1(r);
 copymap12;
 copymap2box;
end;

procedure LineProc(proc : Tmouseproc);
//line drawing
var newpoint : byte;
begin
 case proc of
  mMove : begin
           checkonpoint(newpoint);
           if mouseActive then         //line drawing in progress
            begin
             if (newpoint > 0) and (newpoint <> point1) then
              begin
               unmarkpoint(point2);
               markpoint(newpoint);
               mouseX2 := Alist[newpoint].x;
               mouseY2 := Alist[newpoint].y;
              end;
             if (newpoint = 0) then
              begin
               unmarkpoint(point2);
               mouseX2 := mouseX;
               mouseY2 := mouseY;
              end;
             copymap12;
             drawline(mouseX1,mouseY1,mouseX2,mouseY2,penwidth);
             addrect1(drawrect);
             addrect2(drawrect);
             markpoint(newpoint);
             copymap2box;
             point2 := newpoint;
            end;
           if mouseActive = false then     //no line drawing
            begin
             if newpoint <> point1 then
              begin
               unmarkpoint(point1);
               markpoint(newpoint);
               point1 := newpoint;
              end;
            end;
          end;
  mDown : begin
           map := map2;
           mouseActive := true;
           if point1 = 0 then
           begin
            mouseX1 := mouseX;
            mouseY1 := mouseY
           end
            else begin
                  mouseX1 := Alist[point1].x;
                  mouseY1 := Alist[point1].y;
                 end;
          end;
  mUp   : begin
           if mouseActive then
            begin
             map := map1;
             drawline(mouseX1,mouseY1,mouseX2,mouseY2,penwidth);
             addrect1(drawrect);
             unmarkpoint(point2);
             copymap12;
             copymap2box;
             unmarkpoint(point1);
             mouseActive := false;
            end;
           point1 := 0;
           point2 := 0;
           if form1.checkbox1.checked then ProcIntersections;
          end;
 end;//case
end;

procedure TForm1.Label1MouseEnter(Sender: TObject);
begin
 label1.Color := $00c0ff;
end;

procedure TForm1.Label1MouseLeave(Sender: TObject);
begin
 label1.color := $00ffff;
end;

//-- magnifier --

function MagRect : Trect;
//supply rectangle of magnifier glass
begin
 with result do
  begin
   Left := magX-60;
   Top := magY-60;
   Right := Left+121;
   Bottom := Top + 121;
  end;
end;

procedure paintmagnifierglass;
var r : Trect;
    i,j,m : byte;
    x0,y0,x1,y1,dx,dy : single;
    A,B,C,D,r2,L1,L2 : single;
    Xoffset,Yoffset : smallInt;
    px0,py0,px1,py1 : smallInt;
begin
 case magCode of
  0 : m := 2;   //m : multiplier
  1 : m := 5;
  2 : m := 10;
  else m := 1;
 end;
 with map2 do with canvas do
  begin
   r := magrect;
   addrect1(r);
   addrect2(r);
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   pen.Color := $000060;
   pen.Width := 5;
   ellipse(r.Left+2,r.top+2,r.right-2,r.Bottom-2);
   pen.Color := $000000;
   pen.Width := 1;
//
   r2 := sqr(55);     //magnifier radius squared
   Xoffset := (magX-500)*m;
   Yoffset := (magY-500)*m;
   for i := 1 to edgecount-1 do
    begin
     x0 := m*Alist[i].rx-Xoffset;
     y0 := -m*Alist[i].ry-Yoffset;  //was +
     for j := i+1 to edgecount do
      begin
       x1 := m*Alist[j].rx-Xoffset;
       y1 := -m*Alist[j].ry-Yoffset;
       dx := x1-x0;
       dy := y1-y0;
       A := sqr(dx)+sqr(dy);
       B := 2*(x0*dx+y0*dy);
       C := sqr(x0)+sqr(y0)-r2;
       D := sqr(B)-4*A*C;
       if D > 0 then
        begin
         D := sqrt(D);
         L1 := (-B-D)/(2*A);
         if L1 > 1 then L1 := 1;
         if L1 < 0 then L1 := 0;
         L2 := (-B+D)/(2*A);
         if L2 > 1 then L2 := 1;
         if L2 < 0 then L2 := 0;
         px0 := round(x0+L1*dx)+magX;
         py0 := round(y0+L1*dy)+magY;
         px1 := round(x0+L2*dx)+magX;
         py1 := round(y0+L2*dy)+magY;
         moveto(px0,py0);
         lineto(px1,py1);
        end;
      end;
    end;
   copymap2box;
  end;
end;

procedure magProc(mp : TMouseproc);
//magnifier movement
var r : Trect;
begin
 r := magRect;
 case mp of
  mMove : if mouseActive then
           begin
            copymap12;
            magX := mouseX - magGripX;
            magY := mouseY - magGripY;
            paintmagnifierglass;
            r  := magrect;
            addrect1(magrect);
            addrect2(magrect);
            copymap2box;
           end;
  mDown : begin
           if (mouseX > r.Left) and (mouseX < r.Right) and
              (mouseY > r.Top)  and (mouseY < r.bottom) then
            begin
             mouseActive := true;
             magGripX := mouseX - magX;
             maggripY := mouseY - magY;
            end;
          end;
  mUp   : begin
           mouseActive :=false;
          end;
 end;//case
end;

//-- button events ---

procedure TForm1.SpeedButton1Click(Sender: TObject);
//reset
begin
 setedgecount(3);
 paintcircle;
 map1tobox;
 checkbox1.checked := false;
 statOK := false;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
//select/deselect intersection painting
begin
 if checkbox1.Checked then ProcIntersections
  else begin
        statOK := false;
        paintcircle;
        map1tobox;
       end;
end;

//-- timer , edge control

function IncEdges : boolean;
//increment edges
var E : byte;
begin
 if edgecount = maxEdge then result := false
 else
  begin
   E := edgecount+1;
   if form1.CheckBox2.checked then
    while (E < maxEdge) and (360 mod E > 0) do inc(E);
   setEdgecount(E);
   result := true;
  end;
end;

function decEdges : boolean;
//decrement edges
var E : byte;
begin
 if edgecount = 3 then result := false
  else
   begin
    E := edgecount-1;
    if form1.CheckBox2.checked then
     while (E > 3) and (360 mod E > 0) do  dec(E);
    setEdgeCount(E);
    result := true;
   end;
end;

procedure procStatistics;
var i,n : word;
begin
 for i := 2 to 9 do statistics[i] := 0;
 for i := 1 to INTSlistsize do
  begin
   n := INTSlist[i].count;
   if (n > 1) and (n < 9) then inc(statistics[n])
    else inc(statistics[9]);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var F : boolean;
begin
 if busy then exit;
//
 F := false;
 with timer1 do
  begin
   case timercode of
    0 : Enabled := false;
    1 : F := incEdges;
    2 : F := decEdges;
   end;
  if F then
   begin
    if Interval > 200 then interval := interval - 50;
    paintcircle;
    map1tobox;
   end;
 end;//with timer  
end;

procedure TForm1.Label1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//edge selection
begin
 if busy then begin
               timercode := 0;
               exit;
              end;
//
 statOK := false;
 case button of
  mbLeft  : timercode := 1;
  mbRight : timercode := 2;
 end;
 timer1.Interval := 400;
 timer1.Enabled := true;
 timer1timer(self);
end;

procedure TForm1.Label1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//edge count
begin
 timercode := 0;
 if busy then exit;
//
 if checkbox1.Checked then ProcIntersections;
end;

//-- create / destroy

procedure TForm1.FormCreate(Sender: TObject);
begin
 map1 := Tbitmap.Create;
 with map1 do
  begin
   width := paintbox1.Width;
   height := paintbox1.Height;
  end;
 map2 := Tbitmap.Create;
 with map2 do
  begin
   width := paintbox1.Width;
   height := paintbox1.Height;
  end;
 fullrect := rect(0,0,1001,1001);
 paintcircle;
 addrect1(fullrect);
 copymap12;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 map1.Free;
 map2.Free;
end;

//-- mouse events

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if magSelected then magProc(mDown)
  else Lineproc(mDown);
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 mouseX := x;
 mouseY := y;
 if magSelected then magProc(mMove)
  else Lineproc(mMove);
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if magselected then magProc(mUp)
  else Lineproc(mUp);
end;

procedure TForm1.PaintBox2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//pencolor selection
begin
 colorNr := (x div 30) + (y div 30)*3;
 paintbox2paint(self);
end;

procedure TForm1.PaintBox3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//penwidth selection
begin
 penwidth := (y div 16) + 1;
 paintbox3.Invalidate;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
//save to file
begin
 with savedialog1 do
  if execute then map1.savetofile(filename);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
//clipboard saving
begin
 clipboard.assign(map1);
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
//repaint
begin
 statOK := false;
 paintcircle;
 map1tobox;
 if checkbox1.checked then ProcIntersections;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
//statistics
var x,y,w : word;
    i : byte;
    s : string;
begin
 if statOK = false then exit;
// 
 procStatistics;
 with paintbox1.canvas do
  begin
   brush.color := $ffffff;
   brush.style := bsSolid;
   fillrect(rect(600,100,800,800));
   pen.Width := 2;
   pen.color := $000000;
   moveto(600,100);
   lineto(600,800);
   lineto(800,800);
   lineto(800,100);
   lineto(600,100);
   brush.Style := bsClear;
   font.Name := 'arial';
   font.Height := 20;
   font.color := $000000;
   y := 100;
   x := 610;
   textout(x,y,'statistics');
   inc(y,30);
   textout(x,y,'edges/angles');
   s := inttostr(edgecount);
   w := textwidth(s);
   textout(790-w,y,s);
   inc(y,30);
   textout(x,y,'diagonals');
   w := (edgecount*(edgecount-1) shr 1) - edgecount;
   s := inttostr(w);
   w := textwidth(s);
   textout(790-w,y,s);
   inc(y,50);
   textout(x,y,'intersections');
   inc(y,30);
   for i := 2 to 8 do
    begin
     s := inttostr(i);
     textout(620,y,s);
     s := inttostr(statistics[i]*edgecount);
     w := textwidth(s);
     textout(790-w,y,s);
     inc(y,30);
    end;
   textout(x,y,'  > 8');
   s := inttostr(statistics[9]*9);
   w := textwidth(s);
   textout(790-w,y,s);
   inc(y,30);
   textout(x,y,'center');
   if edgecount and 1 = 0 then w := edgecount shr 1
    else w := 0;
   s := inttostr(w);
   w := textwidth(s);
   textout(790-w,y,s);
   textout(x,780,'repaint to close statistics');
  end;
end;

procedure markMagnification(col : dword; n : byte);
//n : 0,1,2
//col : color
var i : byte;
    r : Trect;
begin
 case n of
  0 : r := rect(0,0,34,24);
  1 : r := rect(36,0,69,24);
  2 : r := rect(71,0,104,24);
 end;
 with form1.EnlBox.canvas do
  begin
   pen.color := col;
   for i := 0 to 2 do
    begin
     moveto(r.left+i,r.TOp+i);
     lineto(r.left+i,r.bottom-i);
     lineto(r.right-i,r.bottom-i);
     lineto(r.right-i,r.TOp+i);
     lineto(r.left+i,r.TOp+i);
    end;
  end;  
end;

procedure TForm1.magnBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 magselected := not magselected;
 magnBoxpaint(self);
 if magselected then
  begin
   magX := 500;
   magY := 500;
   paintmagnifierGlass;
   copymap2box;
  end
  else paintbox1.Canvas.Draw(0,0,map1);
end;

procedure TForm1.EnlBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var n : byte;
begin
 markmagnification($ffffff,magCode);
 n := x div 35;
 markMagnification($ff,n);
 magCode := n;
end;

//-- paints

procedure paintframe(ctrl : TControl; col : dword);
var par : TCustomForm;
    x1,y1,x2,y2 : word;
    i : byte;
begin
 par := getparentform(ctrl);
 with ctrl do
  begin
   x1 := Left-2;
   y1 := top-2;
   x2 := Left + width + 1;
   y2 := top + height + 1;
  end;
 with par.canvas do
  begin
   pen.Color := $000000;
   for i := 0 to 1 do
    begin
     moveto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
     lineto(x1+i,y1+i);
    end;
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
//paint edge around labels and paintboxes
begin
 paintframe(label1,$000000);
 paintframe(paintbox1,$000000);
 paintframe(label3,$000000);
 paintframe(paintbox2,$000000);
 paintframe(paintbox3,$000000);
 paintframe(magNBox,$000000);
 paintframe(EnlBox,$000000);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 addrect2(fullrect);
 copymap2box;
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
//color selection
var i : byte;
    x,y : word;
    r : Trect;
begin
 with paintbox2.Canvas do
  begin
   pen.Color := $000000;
   pen.Width := 1;
   brush.Style := bsSolid;
   for i := 0 to 11 do
    begin
     x := (i mod 3)*30;
     y := (i div 3)*30;
     r := rect(x,y,x+30,y+30);
     brush.color := colorlist[i];
     fillrect(r);
    end;
   i := 0;
   while i < 121 do
    begin
     moveto(0,i);
     lineto(91,i);
     inc(i,30);
    end;
   i := 0;
   while i < 91 do
    begin
     moveto(i,0);
     lineto(i,121);
     inc(i,30);
    end;
   pen.Width := 2;
   if colorNr = 0 then pen.Color := $ffffff else pen.Color :=$000000;
   x := (colorNr mod 3)*30;
   y := (colorNr div 3)*30;
   moveto(x+10,y+10);
   lineto(x+12,y+20);
   lineto(x+18,y+14);
  end;
end;

procedure TForm1.PaintBox3Paint(Sender: TObject);
//penwidth selection
var i : byte;
    y : word;
    r : Trect;
begin
 with paintbox3 do with canvas do
  begin
   brush.Style := bsSolid;
   r.Left := 0;
   r.Right := width;
   pen.color := $000000;
   for i := 1 to 3 do
    begin
     r.top := (i-1)*16;
     r.Bottom := r.Top+16;
     if i = penwidth then brush.Color := $ffffff
      else brush.Color := clBtnFace;
    fillrect(r);
    pen.Width := i;
    y := 16*i - 8;
    moveto(5,y);
    lineto(85,y);
   end;
  end;
end;

procedure TForm1.EnlBoxPaint(Sender: TObject);
//magnification selection
begin
 with enlBox do with canvas do
  begin
   pen.Color := $000000;
   pen.Width := 1;
   brush.color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   moveto(70,0); lineto(70,height);
   moveto(35,0); lineto(35,height);
   brush.Style := bsClear;
   font.Name := 'arial';
   font.Height := 18;
   font.style := [];
   textout(8,3,'x2');
   textout(43,3,'x5');
   textout(75,3,'x10');
  end;
 markmagnification($ff,magCode);
end;

procedure TForm1.magnBoxPaint(Sender: TObject);
begin
 with magnBox do with canvas do
  begin
   brush.Style := bsSolid;
   if magselected then brush.Color := $ffffff else brush.Color := $c0c0c0;
   fillrect(rect(0,0,width,height));
   if magselected then pen.Color := $000000 else pen.color := $808080;
   pen.Width := 4;
   ellipse(10,10,95,95);
  end;
end;

end.



